<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.bonusgroupstrategy_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
      <template slot="menu" slot-scope="{row}">
        <el-button type="text" size="small" icon="el-icon-zoom-in" @click="showAccount(row)">关联账户</el-button>
      </template>
      <template slot="strategyType", slot-scope="{row}">
        <el-tag v-if="row.strategyType === 1" type="success">平台策略</el-tag>
        <el-tag v-if="row.strategyType === 2" type="primary">商户策略</el-tag>
        <el-tag v-if="row.strategyType === 3" type="warning">其他策略</el-tag>
      </template>
    </avue-crud>
    <el-dialog :modal-append-to-body="false" :visible.sync="strategyAccountVisible" title="策略关联账户" width="70%" center top="2vh" modal="true" @close="closeAccountDialog">
      <bonusgroupstrategyaccount :bonus-scene-id="bonusSceneId" :bonus-group-id="bonusGroupId" :bonus-group-strategy-id="bonusGroupStrategyId" v-if="strategyAccountVisible"></bonusgroupstrategyaccount>
    </el-dialog>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/bonus/bonusgroupstrategy";
  import bonusgroupstrategyaccount from "./bonusgroupstrategyaccount.vue"
  import {mapGetters} from "vuex";

  export default {
    components: {
      bonusgroupstrategyaccount
    },
    data() {
      var validateRate = (rule, value, callback)=>{
        if (value === '') {
          callback(new Error('请输入分润比例'));
        } else {
          let pattern = /(^[1-9]([0-9]+)?(\.[0-9]{1,2})?$)|(^(0){1}$)|(^[0-9]\.[0-9]([0-9])?$)/;
          if(pattern.test(value)){
            callback();
          }else{
            callback(new Error('请正确填写分润比例,可保留两位小数'));
          }
          callback();
        }
      };
      return {
        form: {},
        query: {},
        loading: true,
        strategyAccountVisible: false,
        bonusSceneId: null,
        bonusGroupId: null,
        bonusGroupStrategyId: null,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          menuWidth: 300,
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "策略名称",
              prop: "strategyName",
              rules: [{
                required: true,
                message: "请输入分润组策略名称",
                trigger: "blur"
              }]
            },
            {
              label: "业务场景",
              prop: "bonusSceneId",
              type: "select",
              filterable: true,
              dicUrl: "/api/cyzh-bonus-scene/bonusscene/listBonusScene?size=10",
              props:{
                label: "name",
                value: "id"
              },
              rules: [{
                required: true,
                message: "请选择业务场景",
                trigger: "blur",
              }]
            },
            {
              label: "分润商户",
              prop: "bonusGroupId",
              type: "select",
              filterable: true,
              dicUrl: "/api/cyzh-bonus-group/bonusgroup/listBonusGroup?size=500",
              props:{
                label: "name",
                value: "id"
              },
              rules: [{
                required: true,
                message: "请选择分润商户",
                trigger: "blur",
              }]
            },
            {
              label: "分成比例（%）",
              prop: "rate",
              labelWidth: 130,
              rules: [{
                required: true,
                trigger: "blur",
                validator: validateRate
              }]
            },
            {
              label: "类型",
              prop: "strategyType",
              type: "select",
              rules: [{
                required: true,
                message: "请选择分润策略类型",
                trigger: "blur"
              }],
              dicData:[
                {
                  label:"平台策略",
                  value:1
                },
                {
                  label:"商户策略",
                  value: 2
                },
                {
                  label:"其他策略",
                  value: 3
                },
              ],
            },
            {
              label: "策略描述",
              prop: "strategyDesc",
              type: "textarea",
              rules: [{
                required: false,
                message: "请输入策略描述",
                trigger: "blur"
              }]
            }
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.bonusgroupstrategy_add, false),
          viewBtn: this.vaildData(this.permission.bonusgroupstrategy_view, false),
          delBtn: this.vaildData(this.permission.bonusgroupstrategy_delete, false),
          editBtn: this.vaildData(this.permission.bonusgroupstrategy_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      showAccount(row){
        this.bonusSceneId = row.bonusSceneId;
        this.bonusGroupId = row.bonusGroupId;
        this.bonusGroupStrategyId = row.id;
        this.strategyAccountVisible = true;
      },
      closeAccountDialog(){
        this.bonusSceneId = null;
        this.bonusGroupId = null;
        this.bonusGroupStrategyId = null;
        this.strategyAccountVisible = false;
      },
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
